#include <stdio.h>
#include <CUnit/Basic.h>
#include <stdbool.h>
#include "ListeDEntiers.h"

int init_suite_success(void) { 
  return 0; 
}

int clean_suite_success(void) { 
  return 0; 
}


/* mauvaise utilisation des tests unitaires (non boite noire) 
   mais c'est pour ne pas vous penaliser si votre fonction 
   d'insertion de fonctionne pas !!!!
*/
LDE_ListeDEntiers liste1234() {
  LDE_ListeDEntiers result;
  result.nb=4;
  result.entiers = LCDE_listeChainee();
  LCDE_ajouter(&(result.entiers),4);
  LCDE_ajouter(&(result.entiers),3);
  LCDE_ajouter(&(result.entiers),2);
  LCDE_ajouter(&(result.entiers),1);    
  return result;
} 

LDE_ListeDEntiers liste234() {
  LDE_ListeDEntiers result;
  result.nb=3;
  result.entiers = LCDE_listeChainee();
  LCDE_ajouter(&(result.entiers),4);
  LCDE_ajouter(&(result.entiers),3);
  LCDE_ajouter(&(result.entiers),2);  
  return result;
} 

LDE_ListeDEntiers liste124() {
  LDE_ListeDEntiers result;
  result.nb=3;
  result.entiers = LCDE_listeChainee();
  LCDE_ajouter(&(result.entiers),4);
  LCDE_ajouter(&(result.entiers),2);
  LCDE_ajouter(&(result.entiers),1);  
  return result;
}

LDE_ListeDEntiers liste123() {
  LDE_ListeDEntiers result;
  result.nb=3;
  result.entiers = LCDE_listeChainee();
  LCDE_ajouter(&(result.entiers),3);
  LCDE_ajouter(&(result.entiers),2);
  LCDE_ajouter(&(result.entiers),1);  
  return result;
} 

int LCDE_egales(LCDE_ListeChainee l1, LCDE_ListeChainee l2) {
  if (LCDE_estVide(l1) && LCDE_estVide(l2))
    return true;
  else
    if (LCDE_obtenirElement(l1) == LCDE_obtenirElement(l2))
      return LCDE_egales(LCDE_obtenirListeSuivante(l1),LCDE_obtenirListeSuivante(l2));
    else
      return false;
}

int LDE_egales(LDE_ListeDEntiers l1, LDE_ListeDEntiers l2) {
  return (l1.nb == l2.nb) && LCDE_egales(l1.entiers,l2.entiers);
}

void test_liste_vide_vide(void){
  CU_ASSERT_TRUE(LDE_estVide(LDE_listeDEntiers()));
}

void test_liste_non_vide_non_vide(void){
  LDE_ListeDEntiers temp = liste123();
  CU_ASSERT_FALSE(LDE_estVide(temp));
  LDE_supprimerLDE(&temp);
}

void test_longueur_liste_vide(void){
  CU_ASSERT_EQUAL(LDE_longueur(LDE_listeDEntiers()),0);
}

void test_longueur_liste_non_vide(void){
  LDE_ListeDEntiers temp = liste123();
  CU_ASSERT_EQUAL(LDE_longueur(temp),3);
  LDE_supprimerLDE(&temp);
}

void test_longueur_liste_avec_1_entier_de_plus(void){
  LDE_ListeDEntiers temp = liste123();
  unsigned int l = LDE_longueur(temp);
  LDE_inserer(&temp,3,1);
  CU_ASSERT_EQUAL(LDE_longueur(temp),l+1);
  LDE_supprimerLDE(&temp);
}

void test_longueur_liste_avec_1_entier_de_moins(void){
  LDE_ListeDEntiers temp = liste123();
  unsigned int l = LDE_longueur(temp);
  LDE_supprimer(&temp,2);
  CU_ASSERT_EQUAL(LDE_longueur(temp),l-1);
  LDE_supprimerLDE(&temp);
}

void test_longueur_liste_supprimee(void){
  LDE_ListeDEntiers temp = liste123();
  LDE_supprimerLDE(&temp);
  CU_ASSERT_EQUAL(LDE_longueur(temp),0);
}

void test_obtenir_1er_entier(void){
  LDE_ListeDEntiers temp = liste1234();
  CU_ASSERT_EQUAL(LDE_obtenirIemeElement(temp,1),1);
  LDE_supprimerLDE(&temp);
}

void test_obtenir_dernier_entier(void){
  LDE_ListeDEntiers temp = liste1234();
  CU_ASSERT_EQUAL(LDE_obtenirIemeElement(temp,4),4);
  LDE_supprimerLDE(&temp);
}

void test_obtenir_un_entier(void){
  LDE_ListeDEntiers temp = liste1234();
  CU_ASSERT_EQUAL(LDE_obtenirIemeElement(temp,3),3);
  LDE_supprimerLDE(&temp);
}

void test_inserer_un_entier_debut(void){
  LDE_ListeDEntiers l1 = liste234();
  LDE_ListeDEntiers l2 = liste1234();
  LDE_inserer(&l1,1,1);
  CU_ASSERT_TRUE(LDE_egales(l1,l2));
  LDE_supprimerLDE(&l1);
  LDE_supprimerLDE(&l2);  
}

void test_inserer_un_entier_fin(void){
  LDE_ListeDEntiers l1 = liste123();
  LDE_ListeDEntiers l2 = liste1234();
  LDE_inserer(&l1,4,4);
  CU_ASSERT_TRUE(LDE_egales(l1,l2));
  LDE_supprimerLDE(&l1);
  LDE_supprimerLDE(&l2);  
}

void test_inserer_un_entier(void){
  LDE_ListeDEntiers l1 = liste124();
  LDE_ListeDEntiers l2 = liste1234();
  LDE_inserer(&l1,3,3);
  CU_ASSERT_TRUE(LDE_egales(l1,l2));
  LDE_supprimerLDE(&l1);
  LDE_supprimerLDE(&l2);  
}

void test_supprimer_un_entier_debut(void){
  LDE_ListeDEntiers l1 = liste1234();
  LDE_ListeDEntiers l2 = liste234();
  LDE_supprimer(&l1,1);
  CU_ASSERT_TRUE(LDE_egales(l1,l2));
  LDE_supprimerLDE(&l1);
  LDE_supprimerLDE(&l2);  
}

void test_supprimer_un_entier_fin(void){
  LDE_ListeDEntiers l1 = liste1234();
  LDE_ListeDEntiers l2 = liste123();
  LDE_supprimer(&l1,4);
  CU_ASSERT_TRUE(LDE_egales(l1,l2));
  LDE_supprimerLDE(&l1);
  LDE_supprimerLDE(&l2);  
}

void test_supprimer_un_entier(void){
  LDE_ListeDEntiers l1 = liste1234();
  LDE_ListeDEntiers l2 = liste124();
  LDE_supprimer(&l1,3);
  CU_ASSERT_TRUE(LDE_egales(l1,l2));
  LDE_supprimerLDE(&l1);
  LDE_supprimerLDE(&l2);  
}

int main(int argc, char** argv){
  CU_pSuite pSuite = NULL;

  /* initialisation du registre de tests */
  if (CUE_SUCCESS != CU_initialize_registry())
    return CU_get_error();

  /* ajout d'une suite de test */
  pSuite = CU_add_suite("Test Liste d'entiers - LDE (boite noire)", init_suite_success, clean_suite_success);
  if (NULL == pSuite) {
    CU_cleanup_registry();
    return CU_get_error();
  }

  /* Ajout des tests à la suite de tests boite noire */
  if ((NULL == CU_add_test(pSuite, "liste vide est bien vide", test_liste_vide_vide))
      || (NULL == CU_add_test(pSuite, "liste non vide est bien non vide", test_liste_non_vide_non_vide))
      || (NULL == CU_add_test(pSuite, "longueur d'une liste vide à 0", test_longueur_liste_vide))
      || (NULL == CU_add_test(pSuite, "longueur d'une liste non vide", test_longueur_liste_non_vide))
      || (NULL == CU_add_test(pSuite, "longueur d'une liste avec 1 entier de plus", test_longueur_liste_avec_1_entier_de_plus))
      || (NULL == CU_add_test(pSuite, "longueur d'une liste avec 1 entier de moins", test_longueur_liste_avec_1_entier_de_moins))
      || (NULL == CU_add_test(pSuite, "longueur d'une liste supprimee", test_longueur_liste_supprimee))
      || (NULL == CU_add_test(pSuite, "obtenir 1er entier", test_obtenir_1er_entier))
      || (NULL == CU_add_test(pSuite, "obtenir dernier entier", test_obtenir_dernier_entier))
      || (NULL == CU_add_test(pSuite, "obtenir un entier", test_obtenir_un_entier))
      || (NULL == CU_add_test(pSuite, "inserer un entier au debut", test_inserer_un_entier_debut))
      || (NULL == CU_add_test(pSuite, "inserer un entier au fin", test_inserer_un_entier_fin))
      || (NULL == CU_add_test(pSuite, "inserer un entier", test_inserer_un_entier))
      || (NULL == CU_add_test(pSuite, "supprimer un entier au debut", test_supprimer_un_entier_debut))
      || (NULL == CU_add_test(pSuite, "supprimer un entier a la fin", test_supprimer_un_entier_fin))
      || (NULL == CU_add_test(pSuite, "supprimer un entier", test_supprimer_un_entier))      
      )
    {
      CU_cleanup_registry();
      return CU_get_error();
    }

  /* Lancement des tests */
  CU_basic_set_mode(CU_BRM_VERBOSE);
  CU_basic_run_tests();
  printf("\n");
  CU_basic_show_failures(CU_get_failure_list());
  printf("\n\n");

  /* Nettoyage du registre */
  CU_cleanup_registry();
  return CU_get_error();
}
